To execute PROLEAD with default settings, run the following command:

`./release/PROLEAD`

# Command Line Parameters

Moreover, PROLEAD can be executed with different command line parameters:

```
./release/PROLEAD [-pf ?] [-lf/-libraryfile  ?] [-ln/-libraryname ?] [-df/-designfile ?]
                  [-mn/-modulename   ?] [-b ?] [-cf/-configfile  ?] [-ldf/-linkerfile ?]
                  [-rf/-resultfolder ?]
```
If a command line parameter is not specified, PROLEAD considers the default case. Note, that no design and config files are given in the PROLEAD directory. The user has to pick both files from the examples or specify them himself.

| Command Line Parameter | Description | Default Setting |
| ---------------------- | ----------- | --------------- |
| -pf | Select hardware or software version. Defaults to hardware version. To enable software version use this flag and add `sw`. | `hw` |
| -lf/-libraryfile | Sets the specified library file as the standard library file for simulation. The library file should define the functional behavior of each cell in the netlist. Such a file is required for the simulator of PROLEAD to understand how to simulate the cells. | `library.lib` |
| -ln/-libraryname | Sets the specified library name as the standard library name. The library name identifies a unique library in the library file. This is important is multiple libraries are defined in the same library file. | `NANG45`
| -df/-designfile | Sets the specified design file as the standard design file. The design file specifies a gate-level netlist written in Verilog. Such a netlist is produced by synthesizing the circuit's behavioral description. Synthesizing can be done by using a hardware synthesizer, e.g., Design Compiler or Yosys. | `degin.v` |
| -mn/-modulename | Sets the specified module name as the standard module name. The module name specifies the name of the topmodule in the netlist. | `circuit` |
| -b | The software version is able to handle directly binaries as inputs. The parameters for this flag are the path to the binary, path to the disassembled file and path to map file. | |
| -cf/-configfile | Sets the specified config file as the standard config file. The config file defines the evaluation settings. | `config.set` |
| -ldf/-linkerfile | Sets the specified linker file as the standard linker file. | `linker.ld` |
| -rf/-resultfolder | Sets the specified result folder as the standard result folder. All reports are stored in the result folder. | `.` |

# Settings
The evaluation settings are specified in the settings file (usually `config.set`). We remark that some settings are mandatory for every design while other settings are optional. If a required setting is not given in the settings file, PROLEAD returns an error while missing optional settings lead to a warning and the usage of a default setting. We list all settings at <a href="https://github.com/ChairImpSec/PROLEAD/wiki/Settings">Settings</a>.