# Name
compact_distributions

# Type
bool

# Default
no

# Description
Specifies whether PROLEAD evaluates a design in compact mode. By default, PROLEAD operates in normal mode, meaning that all contingency tables are built based on the intermediates. While the evaluation in the normal mode leads to very accurate results, the contingency table can grow very fast and a high amount of RAM is required. To allow the evaluation even with less RAM, the compact mode builds the contingency tables based on the hamming weight of intermediates. The compact mode is less accurate compared to the normal mode while requiring less RAM. It is recommended to use to evaluate large circuits at high security order in the compact mode.

# Examples
```
% Example 1: 
compact_distributions
no % Normal mode.

% Example 2: 
compact_distributions
yes % Compact mode.
```