# Name
effect_size

# Type
float

# Default
0.1

# Description
Specifies the maximum statistical effect size that the underlying test's statistical power should reach. It defines the minimum dependency that the statistical test can detect with a false-negative probability beta. The effect size builds a tradeoff between accuracy and runtime. In particular, the effect size has a direct impact on the number of required traces. Hence, a smaller effect size increases the number of required traces while capturing smaller effects. It is recommended to use the default setting of 0.1 even for low security orders.

# Examples
```
% Example 

effect_size
0.1 % The effect size is set to 0.1.
```