# Name
end_condition

# Type
string

# Description
Specifies a condition to terminate the simulation. In particular, PROLEAD can terminate the simulation if a primary output signal reaches a specific state. For example, PROLEAD can stop the simulation if a done signal is set to logic 1. Alternatively, PROLEAD can terminate the simulation after a specific number of clock cycles.

# Examples
```
% Example 1: 
end_condition
Done 1'b1 % Stop simulation if 'Done' is set to one.

% Example 2: 
end_condition
[31:0] y 32'h89ABCE00 % Stop simulation if vector 'y' is set to 32'h89ABCE00.

% Example 3: 
end_condition
ClockCycles 100 % Stop simulation after 100 clock cycles.
```