# Name
minimize_probe_sets

# Type
bool

# Default
0

# Description
Specifies whether PROLEAD should minimize the number of probing sets. To accelerate the evaluation, PROLEAD can remove probing sets that are fully covered by other probing sets. This leads to a smaller set of probing sets to evaluate. However, searching for covered probing sets is time-consuming. It is recommended to use yes only for small circuits and low security orders due to high complexity.

# Examples
```
% Example 1: 
minimize_probe_sets
no % The probing sets are not minimized and subsets of other probing sets are possible.

% Example 2: 
minimize_probe_sets
yes % The probing sets are minimized. No probing set is a subset of another set.
```