# Name
no_of_groups

# Type
string

# Default
none

# Description
Specifies the number of groups for the test and their corresponding values. For each simulation, PROLEAD randomly chooses one group and simulates the design based on the predefined group value. If a group value contains random bits, PROLEAD refreshes all random bits for each simulation. We recommend evaluating two groups in a fixed vs. fixed or fixed vs. random setting. The setting requires the number of groups followed by a list of group values.

# Examples
```
% Example

no_of_groups
2 % Two groups are conducted for the test.

64'h0000000000000000 % The first group is assigned to a 64-bit zero vector.
64'h$$$$$$$$$$$$$$$$ % The second group is assigned to a 64-bit random vector.
```