# Name
remove_full_probing_sets

# Type
bool

# Default
0

# Description
Specifies whether probing sets whose evaluation does satisfy the given effect size should removed before the evaluation ends. Hence, small probing sets are only evaluated if the required effect size is not achieved. The more simulations are considered the fewer probing sets have to be evaluated. This accelerates the evaluation in the normal mode.

# Examples
```
% Example 1: 
remove_full_probing_sets
no % All probing sets take the complete set of simulations into account.

% Example 2: 
remove_full_probing_sets
yes % If a probing set can satisfy the required statistical power, it will be removed.
```